<template>
  <div id="user-card-list">
    <user-card v-for="(user, index) in userList"
    :user="user"
    :index="index"
    :key="index">
    </user-card>
    <div class="loading-spinner-overlay" v-if="loading"></div>
  </div>
</template>

<script>
import userCard from './UserCard.vue';
import store from '../store/index';
import { mapState } from 'vuex';
import axios from 'axios';
import { proxy } from '../config/proxy';

export default {
  computed: {
    ...mapState([
      'userList',
    ]),
  },
  data() {
    return {
      loading: false,
    };
  },
  components: {
    userCard,
  },
  created() {
    // avoid getting user list if we already have it
    if (this.userList.length) return;
    // toggle loading spinner on
    this.loading = true;
    // http request
    axios.get(proxy + '/api/users').then((response) => {
      // get users successful
      store.commit('getUsersSuccessful', {
        users: response.data,
      });
      // toggle loading spinner off
      this.loading = false;
    }).catch((error) => {
      // log error message
      console.log({ error: error.message });
      // toggle loading spinner off
      this.loading = false;
    });
  },
}
</script>

<style lang="scss">

</style>
